<template>
  <div id="app">
    <span :src="user_data">{{user_data}}</span> <br><br>
    <button @click="fetchJoke">{{ button }}</button>
    <p v-if="error">{{ error }}</p>
    <div class="wrapper">
      <p class="question" v-if="question">{{ question }}</p>
      <button v-if="answer" v-show="!reveal" @click="revealAnswer">?</button>
      <p class="answer" v-if="reveal">{{ answer }}</p>
    </div>
  </div>
</template>


<script>
import axios from 'axios'
/* eslint-disable */
export default {
  name: 'HomeView',
  data() {
    return {
      user_data: '',
      button: "Get A Dad Joke ",
      answer: null,
      question: null,
      reveal: false,
      error: null
    };
  },
  mounted() {
    this.getMe()
  },
  methods: {
      getMe(e) {
      axios
        .get("/api/v1/users/me")
        .then(response => {
          this.user_data = response.data.username
        })
        .catch(error => {
          console.log(error)
        })
    },
    splitJoke(str) {
      return str.joke.split("? ").map((j) => j.trim());
    },
    resetJokes() {
      this.question = false;
      this.answer = false;
      this.reveal = false;
    },
    revealAnswer() {
      this.reveal = true;
    },
    fetchJoke() {
      this.resetJokes();
      fetch("https://icanhazdadjoke.com", {
        headers: {
          Accept: "application/json"
        }
      })
        .then((res) => {
          return res.json();
        })
        .then((resjson) => {
          const formatted = this.splitJoke(resjson);
          formatted.length > 1
            ? (this.question = formatted[0] + "?")
            : (this.question = formatted[0]);
          this.answer = formatted[1];
          this.button = "Hit Me One More Time.";
        })
        .catch((error) => {
          this.error = "Something went wrong. Try again later.";
        });
    }
  }
};
/* eslint-enable */
</script>

<!-- Use preprocessors via the lang attribute! e.g. <style lang="scss"> -->
<style>
* {
  box-sizing: border-box;
  margin: 0px;
}

#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  text-align: center;
  color: #000000;
  margin-top: 60px;
}

button:hover {
  cursor: pointer;
}

button {
  background: #00100b;
  border: none;
  font: inherit;
  padding: 0.75em 2em;
  color: white;
  font-weight: 800;
  box-shadow: 3px 4px 10px rgb(0, 0, 0, 0.4);
}

p {
  padding: 20px;
  font-size: 1.2rem;
  font-weight: 500;
  border-radius: 10px;
  box-shadow: 10px 10px black;
  width: 500px;
  height: auto;
  animation: zoom 0.2s;
  margin: 40px auto;
}

.wrapper button {
  animation: fadeIn 1s;
}

@keyframes fadeIn {
  0% {
    opacity: 0;
  }
  100% {
    opacity: 1;
  }
}

.question {
  background: #fff07c;
}

.answer {
  background: #394648;
  color: #fff07c;
  font-size: 1.4rem;
}

@keyframes zoom {
  0% {
    transform: scale(0);
  }
  100% {
    transform: scale(1);
  }
}

footer {
  position: absolute;
  bottom: 0%;
  margin: 0 auto;
  width: 100%;
}
</style>

